''
''2016
''Jaime Montenegro
''
''

                                
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  i2cclkpin = 6
  i2cdatpin = 7
  baudrate  = 57_600
 '' initaddr  = 21846
  devaddr   = %1010000
VAR
  long stack[600]
  long addallo[6]
OBJ
   
  pst           : "Parallax Serial Terminal"
  rtc           : "DSRTC_driver"
  i2c           : "Very Basic I2C"
PUB Main  | index, cogmeter[6]    '' index will be used to loop for as many meters (cogmeter[]) are connected
                                  '' each meter will be read individually by 1 cog
    pst.Start(baudrate)
    rtc.rtcEngineStart(i2cdatpin, i2cclkpin, -1)
    pst.Clear
    i2c.Initialize                          '' initializing i2c modules
    
    addallo[0] := 0                         '' allocating memory address for each meter/cog 
    addallo[1] := 21846
    addallo[2] := 43692
    addallo[3] := 65538
    addallo[4] := 87384
    addallo[5] := 109230
    
    
    repeat index from 0 to 5                ''index will be used to enter meter initial values
    
       pst.Str(String("Enter meter "))        ''and also for pin assignment in the board
       pst.Dec(index + 1)                      ''(passing index as parameter in pulsedet function) 
       pst.Str(String(" initial reading: "))
       cogmeter[index] := pst.DecIn
       pst.NewLine
       cognew (pulsedet(index, cogmeter[index]), @stack[index * 100])
    

PUB pulsedet (optin,pulcnt)  | time 

    
    dira[optin]~
        
    repeat
       
       if ina[optin] == 1
          
          time := deltat(optin)
             if time > 2_000_000
                rtc.readClock
                pulcnt ++
                pst.Str(String("Current meter reading: "))
                pst.Dec(pulcnt)
                pst.Str(String("  "))
                DispTime(optin, pulcnt)
                pst.Str(String("From pin: "))
                pst.Dec(optin)
                pst.Str(String(" meter ID: "))
                pst.Dec(optin + 1)
                pst.Newline
                pst.Newline
       waitcnt(clkfreq / 20 + cnt)
    
PUB DispTime (index, pulcnt) | pdata[8] , rdata[8] 

    
  pdata[0] := pulcnt
  
  pdata[1] := rtc.clockMonth
  pst.Dec(pdata[1])
  pst.Str(String("/"))
  
  pdata[2] := rtc.clockDate
  pst.Dec(pdata[2])
  pst.Str(String("/"))

  pdata[3] := rtc.clockYear
  pst.Dec(pdata[3])
  pst.Str(String(" "))

  pdata[4] := rtc.clockHour
  pst.Dec(pdata[4])
  pst.Str(String(":"))

  pdata[5] := rtc.clockMinute
  pst.Dec(pdata[5])
  pst.Str(String(":"))
  
  pdata[6] := rtc.clockSecond
  pst.Dec(pdata[6])
  pst.Str(String(" "))

  pdata[7] := rtc.clockAMPM
  if(pdata[7] == 1)
    pst.Str(string("PM"))            
  else
    pst.Str(string("AM"))

  pst.Newline

''''' Writing to EEPROM
                                               '' I NEED HELP IN THIS SECTION, BECAUSE I NEED TO WRITE AND READ pdata[0] 
  i2c.Start                                    '' IN THE EEPROM AS A LONG VALUE BUT THE Very Basic I2C OBJECT THAT I AM  
  i2c.ByteWrite(addallo[index] , pdata[0])     '' USING DOES NOT CONTAIN METHODS TO WRITE OR READ LONG VALUES
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 4, pdata[1])
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 5, pdata[2])
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 6, pdata[3] -2000)
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 7, pdata[4])
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 8, pdata[5])
  i2c.Stop

  i2c.Start
  i2c.ByteWrite(addallo[index] + 9, pdata[6])
  i2c.Stop
    
  i2c.Start
  i2c.ByteWrite(addallo[index] + 10, pdata[7])
  i2c.Stop 


''''' The following code is to test if writing to EEPROM was sucessful '

  pst.Str(String("Reading EEPROM: "))

  i2c.Start                                       '' I NEED HELP IN THIS SECTION, BECAUSE I NEED TO WRITE AND READ pdata[0]
  rdata[0] := i2c.RandomRead(addallo[index])      '' IN THE EEPROM AS A LONG VALUE BUT THE Very Basic I2C OBJECT THAT I AM
  i2c.Stop                                        '' USING DOES NOT CONTAIN METHODS TO WRITE OR READ LONG VALUES
  pst.Dec(rdata[0])
  pst.Str(String(" "))
  
  i2c.Start
  rdata[1] := i2c.RandomRead(addallo[index] + 4)
  i2c.Stop
  pst.Dec(rdata[1])
  pst.Str(String("/"))

  i2c.Start
  rdata[2] := i2c.RandomRead(addallo[index] + 5)
  i2c.Stop
  pst.Dec(rdata[2])
  pst.Str(String("/"))

  i2c.Start
  rdata[3] := i2c.RandomRead(addallo[index] + 6)
  i2c.Stop
  pst.Dec(rdata[3])
  pst.Str(String("/"))

  i2c.Start
  rdata[4] := i2c.RandomRead(addallo[index] + 7)
  i2c.Stop
  pst.Dec(rdata[4])
  pst.Str(String("/"))

  i2c.Start
  rdata[5] := i2c.RandomRead(addallo[index] + 8)
  i2c.Stop
  pst.Dec(rdata[5])
  pst.Str(String("/"))

  i2c.Start
  rdata[6] := i2c.RandomRead(addallo[index] + 9)
  i2c.Stop
  pst.Dec(rdata[6])
  pst.Str(String("/"))

  i2c.Start
  rdata[7] := i2c.RandomRead(addallo[index] + 10)
  i2c.Stop
  if(rdata[7] == 1)
    pst.Str(string("PM"))            
  else
    pst.Str(string("AM"))
  addallo[index] += 11
  pst.Newline
    
PUB deltat(pin) : delta | time1, time2

    ''repeat until ina[pin] == 1
    time1 := cnt
    repeat until ina[pin] == 0
    time2 := cnt
    delta := time2 - time1